package com.zipcodewilmington.gildedrose;

import org.junit.Assert;
import org.junit.Test;

public class InventoryTest {

    // Given
    Item agedBrie = new Item("Aged Brie", 10, 5);
    Item backstagePasses = new Item("Backstage passes to a TAFKAL80ETC concert", 5, 10);
    Item sulfuras = new Item("Sulfuras, Hand of Ragnaros", 15, 15);
    Item random = new Item("Random Items", 0, 7);
    Item[] items = {agedBrie, backstagePasses, sulfuras, random};
    Inventory inventory = new Inventory(items);

    @Test
    public void updateQuantityTest() {
        // Given
        agedBrie.setSellIn(10);
        int expected = 10 - 1;

        //  When
        inventory.updateQuality();
        int actual = agedBrie.getSellIn();

        // Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void updateQuantityTest2() {
        // Given
        random.setName("Plan Old Java Objects");
        int expected = 0 - 1;

        // When
        inventory.updateQuality();
        int actual = random.getSellIn();

        // Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void updateQuantityTest3() {
        // Given
        backstagePasses.setSellIn(-5);
        backstagePasses.setQuality(75);
        int expected = 75 - 75;

        // When
        inventory.updateQuality();
        int actual = backstagePasses.getQuality();

        // Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void updateQuantityTest4() {
        // Given
        agedBrie.setSellIn(-7);
        agedBrie.setQuality(41);
        int expected = 41 + 1 + 1;

        // When
        inventory.updateQuality();
        int actual = agedBrie.getQuality();

        // Then
        Assert.assertEquals(expected, actual);
    }
}

